# blinker-library
Blinker library for embedded hardware. Works with Arduino, ESP8266, ESP32.  

# What's Blinker
[Blinker](https://blinker.app/) is a cross-hardware, cross-platform solution for the IoT. It provides APP, device and server support, and uses public cloud services for data transmission and storage. It can be used in smart home, data monitoring and other fields to help users build Internet of Things projects better and faster.   
  
[Blinker](https://blinker.app/) 是一套跨硬件、跨平台的物联网解决方案，提供APP端、设备端、服务器端支持，使用公有云服务进行数据传输存储。可用于智能家居、数据监测等领域，可以帮助用户更好更快地搭建物联网项目。  

# Reference/参考
* [EN-英文](https://github.com/blinker-iot/blinker-doc/wiki/Blinker-Arduino-library-reference)  
* [CN-中文](https://github.com/blinker-iot/blinker-doc/wiki/Blinker-Arduino-%E5%BA%93%E4%BD%BF%E7%94%A8%E6%89%8B%E5%86%8C)  
* [CN-中文/官网](https://doc.blinker.app/?file=003-%E7%A1%AC%E4%BB%B6%E5%BC%80%E5%8F%91/02-Arduino%E6%94%AF%E6%8C%81)  
# Thanks
[WebSockets](https://github.com/Links2004/arduinoWebSockets) - for Blinker to build up a websocket server  
[Adafruit_MQTT_Library](https://github.com/adafruit/Adafruit_MQTT_Library) - for Blinker to build up a mqtt client  
[ArduinoJson](https://github.com/bblanchon/ArduinoJson) - for Blinker to format Json data   
[Blynk](https://github.com/blynkkk/blynk-library)  

Due to frequent updates of versions, individual items may not be added in time. We hope to understand. If you find out, please let us know.

# 感谢
[WebSockets](https://github.com/Links2004/arduinoWebSockets) - Blinker 用这个库建立了一个 websocket 服务器  
[Adafruit_MQTT_Library](https://github.com/adafruit/Adafruit_MQTT_Library) - Blinker 用这个库建立了一个 MQTT 客户端  
[ArduinoJson](https://github.com/bblanchon/ArduinoJson) - Blinker 用这个库解析 Json   
[Blynk](https://github.com/blynkkk/blynk-library)  

由于版本更新频繁，个别项目可能没有及时添加，望理解，如有发现可告知我们